Uses Crt, Strings, WinDos;

{Tll ohjelmalla voi knt
 NES-tiedostoja toimivaksi 80286 -assembler-koodiksi,
 kunhan ne eivt sisll itsen muuttavaa koodia
 eivtk tutki aliohjelmissa kutsuosoitteitaan.}

Const
	Gen86: Boolean = False;

Procedure BHex(s: PChar; b: Byte);
Const HC: Array[0..15]Of Char = '0123456789ABCDEF';
Begin
	s[0] := HC[b Shr 4];
	s[1] := HC[b And 15];
	s[2] := #0
End;

Procedure WHex(s: PChar; w: Word);
Begin
	BHex(s+0, WordRec(w).Hi);
	BHex(s+2, WordRec(w).Lo)
End;

Procedure LHex(s: PChar; l: LongInt);
Begin
	WHex(s+0, LongRec(l).Hi);
	WHex(s+4, LongRec(l).Lo);
End;

Var
	Counter:  LongInt;

Const
	Ac=0; Zx=5; Ix=10;
	Il=1; Zy=6; Iy=11;
	Im=2; Ax=7;_In=12;
	Ab=3; Ay=8;Arr=13;
	Zp=4; Rl=9; No=127;
	Iw=14;
	(* These are the addressation methods used by 6502 CPU. *)

Const MN: Array[0..56]Of PChar =
(
	'adc a,','and a,','sal',    'jnc',    'jc',     'je',     'bit',    'js',
	'jne'   ,'jns'   ,'brk',    'jno',    'jo',     'clc',    'clD',    'cli',
	'clo'   ,'cmp a,','cmp x,', 'cmp y,', 'dec',    'dec x',  'dec y',  'inc x',
	'inc y' ,'xor a,','inc',    'jmp',    'call',   'mov a,', 'nop',    'mov x,',
	'mov y,','shr'   ,'or a,',  'push a', 'pushf',  'pop a',  'popf',   'rol',
	'ror'   ,'iret'  ,'ret',    'sbb a,', 'sta',    'stx',    'sty',    'stc',
	'stD'   ,'sti'   ,'mov x,a','mov y,a','mov a,x','mov a,y','mov x,s','mov s,x',
	{C64-mnemonics?}
	'arr a,'
);
{D-flag does not mean direction - it means decimal mode}

Const
	AD: Array[0..511]Of Byte =
(
	10,Il, 34,Ix, No,No, No,No, No,No, 34,Zp,  2,Zp, No,No,
	36,Il, 34,Im,  2,Ac, No,No, No,No, 34,Ab,  2,Ab, No,No,
	 9,Rl, 34,Iy, No,No, No,No, No,No, 34,Zx,  2,Zx, No,No,
	13,Il, 34,Ay, No,No, No,No, No,No, 34,Ax,  2,Ax, No,No,
	28,Iw,  1,Ix, No,No, No,No,  6,Zp,  1,Zp, 39,Zp, No,No,
	38,Il,  1,Im, 39,Ac, No,No,  6,Ab,  1,Ab, 39,Ab, No,No,
	 7,Rl,  1,Iy, No,No, No,No, No,No,  1,Zx, 39,Zx, No,No,
	47,Il,  1,Ay, No,No, No,No, No,No,  1,Ax, 39,Ax, No,No,
	41,Il, 25,Ix, No,No, No,No, No,No, 25,Zp, 33,Zp, No,No,
	35,Il, 25,Im, 33,Ac, No,No, 27,Ab, 25,Ab, 33,Ab, No,No,
	11,Rl, 25,Iy, No,No, No,No, No,No, 25,Zx, 33,Zx, No,No,
	15,Il, 25,Ay, No,No, No,No, No,No, 25,Ax, 33,Ax, No,No,
	42,Il,  0,Ix, No,No, No,No, No,No,  0,Zp, 40,Zp, No,No,
	37,Il,  0,Im, 40,Ac, 56,Im, 27,_In, 0,Ab, 40,Ab, No,No,
	12,Rl,  0,Iy, No,No, No,No, No,No,  0,Zx, 40,Zx, No,No,
	49,Il,  0,Ay, No,No, No,No, No,No,  0,Ax, 40,Ax, No,No,
	No,No, 44,Ix, No,No, No,No, 46,Zp, 44,Zp, 45,Zp, No,No,
	22,Il, No,No, 52,Il, No,No, 46,Ab, 44,Ab, 45,Ab, No,No,
	 3,Rl, 44,Iy, No,No, No,No, 46,Zx, 44,Zx, 45,Zy, No,No,
	53,Il, 44,Ay, 55,Il, No,No, No,No, 44,Ax, No,No, No,No,
	32,Im, 29,Ix, 31,Im, No,No, 32,Zp, 29,Zp, 31,Zp, No,No,
	51,Il, 29,Im, 50,Il, No,No, 32,Ab, 29,Ab, 31,Ab, No,No,
	 4,Rl, 29,Iy, No,No, No,No, 32,Zx, 29,Zx, 31,Zy, No,No,
	16,Il, 29,Ay, 54,Il, No,No, 32,Ax, 29,Ax, 31,Ay, No,No,
	19,Im, 17,Ix, No,No, No,No, 19,Zp, 17,Zp, 20,Zp, No,No,
	24,Il, 17,Im, 21,Il, No,No, 19,Ab, 17,Ab, 20,Ab, No,No,
	 8,Rl, 17,Iy, No,No, No,No, No,No, 17,Zx, 20,Zx, No,No,
	14,Il, 17,Ay, No,No, No,No, No,No, 17,Ax, 20,Ax, No,No,
	18,Im, 43,Ix, No,No, No,No, 18,Zp, 43,Zp, 26,Zp, No,No,
	23,Il, 43,Im, 30,Il, No,No, 18,Ab, 43,Ab, 26,Ab, No,No,
	 5,Rl, 43,Iy, No,No, No,No, No,No, 43,Zx, 26,Zx, No,No,
	48,Il, 43,Ay, No,No, No,No, No,No, 43,Ax, 26,Ax, No,No
);

Var
	OP: Integer;
	RelAddr: LongInt;
	C: PChar;

(** DAsm() ****************************************************)
(** This function will disassemble a single command and      **)
(** return the number of bytes disassembled.                 **)
(**************************************************************)
Function DAsm(S, A: PChar; PC: LongInt): Integer;
Var
	w: Word;
	B: PByte;
	J: Byte;
Begin
	B := PByte(A);
	C := A;
	OP := (B^)*2; Inc(B);

	strcpy(s, MN[AD[OP]]);

	Case AD[OP+1]Of
		Ac: strcat(s, ' a');
		Il: ;
		Rl:
		Begin
			J := B^; Inc(B);
			Inc(PC, 2);
			If J<$80 Then Inc(PC, J)Else Inc(PC, J-256);
			strcat(s, ' ');
			RelAddr := PC;
			LHex(strend(s), PC)
		End;
		Im:
		Begin
			strcat(s, ' ');
			BHex(strend(s), B^);
			Inc(B)
		End;
		Zp:
		Begin
			strcat(s, ' [00');
			BHex(strend(s), B^);
			strcat(s, ']');
			Inc(B)
		End;
		Zx:
		Begin
			strcat(s, ' [00');
			BHex(strend(s), B^);
			strcat(s, '+x]');
			Inc(B)
		End;
		Zy:
		Begin
			strcat(s, ' [00');
			BHex(strend(s), B^);
			strcat(s, '+y]');
			Inc(B)
		End;
		Ix:
		Begin
			strcat(s, ' [word[(x+');
			BHex(strend(s), B^);
			strcat(s, ')&FF]]');
			Inc(B)
		End;
		Iy:
		Begin
			strcat(s, ' [y+word[00');
			BHex(strend(s), B^);
			strcat(s, ']]');
			Inc(B)
		End;
		Ab:
		Begin
			w :=           B^; Inc(B);
			w := B^ Shl 8 + w; Inc(B);
			RelAddr := w;
			strcat(s, ' [');
			WHex(strend(s), w);
			strcat(s, ']')
		End;
		Iw:
		Begin
			w :=           B^; Inc(B);
			w := B^ Shl 8 + w; Inc(B);
			RelAddr := w;
			strcat(s, ' ');
			WHex(strend(s), w)
		End;
		Ax:
		Begin
			w := B^          ; Inc(B);
			w := B^ Shl 8 + w; Inc(B);
			strcat(s, ' [');
			WHex(strend(s), w);
			strcat(s, '+x]')
		End;
		Ay:
		Begin
			w := B^          ; Inc(B);
			w := B^ Shl 8 + w; Inc(B);
			strcat(s, ' [');
			WHex(strend(s), w);
			strcat(s, '+y]')
		End;
		_In:
		Begin
			w := B^          ; Inc(B);
			w := B^ Shl 8 + w; Inc(B);
			RelAddr := w;
			strcat(s, ' [');
			WHex(strend(s), w);
			strcat(s, ']')
		End;
		Else
		Begin
			strcpy(s, 'db ');
			BHex(strend(s), OP Shr 1)
		End;
	End;
	DAsm := PChar(B) - A
End;

Function UnHex(s: PChar): LongInt; Assembler;
Asm
	les si, s
	xor ax, ax
	xor dx, dx
	xor bh, bh
@@1:
	mov bl, es:[si]
	or bl, bl
	jz @@9
	and bl, not 32
	sub bl, 16
	cmp bl, 9
	ja @@3
@@2:
	push bx
	 mov bx, 10
	 mov cx, 0
	 call LongMul
	pop bx
	add ax, bx
	adc dx, 0
	jmp @@1
@@3:
	sub bl, 39
	jmp @@2
@@9:
End;

Var
	pROM: Array[0..63]Of PChar;
	pROMCount: Integer;

	vROM: Array[0..63]Of PChar;
	vROMCount: Integer;

	fROM: Array[0..63]Of PChar;
	{bit values:}
	{ 1 = Has executable code}
	{ 2 = }
	{ 4 = }
	{ 8 = }
	{10 = }
	{20 = }
	{40 = }
	{80 = Has been read}

	Trainer: PChar;

	HasTrainer: Boolean;

	NESFlags: Word;
	Mapper: Byte;

	Pages: Array[0..15]Of Integer;

	LocalLoc: Integer;
	HexBuf: Array[0..8]Of Char;

Procedure FlagSet(Value: Word; Reg: PChar);
Begin
	If Reg = Nil Then
	Begin
		Reg := 'al';
		If Value = $FFFF Then
		Begin
			WriteLn(#9'call FlagSet');
			Exit
		End
	End;
	WriteLn(#9'and FlagReg, 7Dh'#9';Clear ZF+SF');
	If Value >= $FFFE Then
	Begin
		WriteLn(#9'or ',Reg,', ',Reg);
		WriteLn(#9'mov al, 0');
		WriteLn(#9'js @@',LocalLoc);
		WriteLn(#9'jnz @@',LocalLoc+1);
		WriteLn(#9'mov al, 82h'#9#9';SF+82H=ZF');
		Write('@@',LocalLoc,':'); Inc(LocalLoc);
		WriteLn(#9'xor al, 80h'#9#9';SF');
		Write('@@',LocalLoc,':'); Inc(LocalLoc);
		WriteLn(#9'or FlagReg, al')
	End
	Else If Value =   0 Then WriteLn(#9'xor FlagReg, 2'#9#9';Set ZF')
	Else If Value > 127 Then WriteLn(#9'xor FlagReg, 80h'#9#9';Set SF')
End;

Procedure FlagSetCmp(Reg: PChar);
Begin
	If Reg = Nil Then
	Begin
		WriteLn(#9'call FlagSetCmp');
		Exit
	End;
	If Reg = PChar(1) Then Reg := 'al';
	WriteLn(#9'and FlagReg, 7Ch'#9';Clear ZF+SF+CF');

	WriteLn(#9'or ',Reg,', ',Reg);
	WriteLn(#9'mov al, 0');
	WriteLn(#9'js @@',LocalLoc);
	WriteLn(#9'jnz @@',LocalLoc+1);
	WriteLn(#9'mov al, 82h'#9';SF+82H=ZF');
	Write('@@',LocalLoc,':'); Inc(LocalLoc);
	WriteLn(#9'xor al, 80h'#9';SF');
	Write('@@',LocalLoc,':'); Inc(LocalLoc);
	WriteLn(#9'or dh, dh');
	WriteLn(#9'jnz @@',LocalLoc);
	WriteLn(#9'or al, 1'#9';CF');
	Write('@@',LocalLoc,':'); Inc(LocalLoc);
	WriteLn(#9'or FlagReg, al')
End;

Procedure FlagSetBit;
Begin
	WriteLn(#9'and FlagReg, 3Dh'#9';Clear SF+OF+ZF');

	WriteLn(#9'mov dh, al');
	WriteLn(#9'and al, 0C0h');
	WriteLn(#9'test dh, ah');
	WriteLn(#9'jnz @@',LocalLoc);
	WriteLn(#9'or al, 2');
	Write('@@',LocalLoc,':'); Inc(LocalLoc);
	WriteLn(#9'or FlagReg, al');
	WriteLn(#9'xor dh, dh')
End;

Procedure ReadSource(s: PChar);
Label IxIy;
Begin
	If Not Gen86 Then Exit;
	Case AD[OP+1]Of
		Im:
		Begin
			If(s=Nil)Or(s^ = #0)Then
			Begin
				If C[1] = #0
					Then WriteLn(#9'xor al, al')
					Else WriteLn(#9'mov al, ',Ord(C[1]));
				If s=Nil Then FlagSet(Ord(C[1]), Nil);
				Exit
			End;
			WriteLn(s, Ord(C[1]))
		End;
		Ab:
		Begin
			WHex(HexBuf, PWord(C+1)^);
			If strcmp(HexBuf, '0000') = 0
				Then WriteLn(#9'xor si, si')
				Else WriteLn(#9'mov si, 0',HexBuf,'h');
			WriteLn(#9'call Read');
			If(s<>Nil)And(s^<>#0)Then WriteLn(s, 'al')
		End;
		Zp:
		Begin
			BHex(HexBuf, PByte(C+1)^);
			If strcmp(HexBuf, '00') = 0
				Then WriteLn(#9'xor si, si')
				Else WriteLn(#9'mov si, 000',HexBuf,'h');
			WriteLn(#9'call Read');
			If(s<>Nil)And(s^<>#0)Then WriteLn(s, 'al')
		End;
		Zx:
		Begin
			BHex(HexBuf, PByte(C+1)^);
			WriteLn(#9'mov di, bx');
			WriteLn(#9'add bl, 0',HexBuf,'h');
			WriteLn(#9'mov si, bx');
			WriteLn(#9'mov cx, di');
			WriteLn(#9'call Read');
			If(s<>Nil)And(s^<>#0)Then WriteLn(s, 'al')
		End;
		Zy:
		Begin
			BHex(HexBuf, PByte(C+1)^);
			WriteLn(#9'mov di, cx');
			WriteLn(#9'add cl, 0',HexBuf,'h');
			WriteLn(#9'mov si, cx');
			WriteLn(#9'mov cx, di');
			WriteLn(#9'call Read');
			If(s<>Nil)And(s^<>#0)Then WriteLn(s, 'al')
		End;
		Ax:
		Begin
			WHex(HexBuf, PWord(C+1)^);
			If strcmp(HexBuf, '0000') = 0
				Then WriteLn(#9'mov si, bx')
				Else WriteLn(#9'lea si, [bx + 0',HexBuf,'h]');
			WriteLn(#9'call Read');
			If(s<>Nil)And(s^<>#0)Then WriteLn(s, 'al')
		End;
		Ay:
		Begin
			WHex(HexBuf, PWord(C+1)^);
			WriteLn(#9'mov si, cx');
			If strcmp(HexBuf, '0000') <> 0 Then WriteLn(#9'add si, 0',HexBuf,'h');
			WriteLn(#9'call Read');
			If(s<>Nil)And(s^<>#0)Then WriteLn(s, 'al')
		End;
		Ix:
		Begin
			WriteLn(#9'mov di, bx');
			BHex(HexBuf, PByte(C+1)^);
			If strcmp(HexBuf, '00') <> 0 Then WriteLn(#9'add bl, 0',HexBuf,'h');
			WriteLn(#9'mov si, bx');
			WriteLn(#9'mov bx, di');
			WriteLn(#9'call Read');
IxIy:	WriteLn(#9'mov si, ax');
			WriteLn(#9'and si, 255');
			WriteLn(#9'call Read');
			If(s<>Nil)And(s^<>#0)Then WriteLn(s, 'al')
		End;
		Iy:
		Begin
			BHex(HexBuf, PByte(C+1)^);
			If strcmp(HexBuf, '00') = 0
				Then WriteLn(#9'xor si, si')
				Else WriteLn(#9'mov si, 000',HexBuf,'h');
			WriteLn(#9'call Read');
			WriteLn(#9'add al, cl');
			Goto IxIy
		End
	End;
	If s^ <> #0 Then FlagSet($FFFF, Nil)
End;

Procedure WriteDest;
Label ZxZy;
Begin
	Case AD[OP+1]Of
		Im:
			WriteLn(#9#7#9';Can''t write to a immediate value'^G);
		Ab:
		Begin
			WHex(HexBuf, PWord(C+1)^);
			If strcmp(HexBuf, '0000') = 0
				Then WriteLn(#9'xor di, di')
				Else WriteLn(#9'mov di, 0',HexBuf,'h');
			WriteLn(#9'call Write')
		End;
		Zp:
		Begin
			BHex(HexBuf, PByte(C+1)^);
			If strcmp(HexBuf, '00') = 0
				Then WriteLn(#9'xor di, di')
				Else WriteLn(#9'mov di, 000',HexBuf,'h');
			WriteLn(#9'call Write')
		End;
		Zx:
		Begin
			BHex(HexBuf, PByte(C+1)^);
			WriteLn(#9'mov dh, ah');
			WriteLn(#9'mov ax, bx');
			Goto ZxZy;
		End;
		Zy:
		Begin
			WriteLn(#9'mov si, cx');
ZxZy:	BHex(HexBuf, PByte(C+1)^);
			If strcmp(HexBuf, '00') <> 0 Then WriteLn(#9'add cl, 0',HexBuf,'h');
			WriteLn(#9'mov di, cx');
			WriteLn(#9'mov cx, si');
			WriteLn(#9'call Write')
		End;
		Ax:
		Begin
			WHex(HexBuf, PWord(C+1)^);
			If strcmp(HexBuf, '0000') = 0
				Then WriteLn(#9'mov di, bx')
				Else WriteLn(#9'lea di, [bx + 0',HexBuf,'h]');
			WriteLn(#9'call Write')
		End;
		Ay:
		Begin
			WHex(HexBuf, PWord(C+1)^);
			WriteLn(#9'mov di, cx');
			If strcmp(HexBuf, '0000') <> 0
				Then WriteLn(#9'add di, 0',HexBuf,'h');
			WriteLn(#9'call Write')
		End;
		Ix:
		Begin
			WriteLn(#9'mov si, bx');
			BHex(HexBuf, PByte(C+1)^);
			If strcmp(HexBuf, '00') <> 0 Then WriteLn(#9'add bl, 0',HexBuf,'h');
			WriteLn(#9'mov di, bx');
			WriteLn(#9'mov bx, si');
			WriteLn(#9'push ax');
			WriteLn(#9' call Read');
			WriteLn(#9' xor ah, ah');
			WriteLn(#9' mov di, ax');
			WriteLn(#9'pop ax');
			WriteLn(#9'call Write')
		End;
		Iy:
		Begin
			BHex(HexBuf, PByte(C+1)^);
			If strcmp(HexBuf, '00') = 0
				Then WriteLn(#9'xor di, di')
				Else WriteLn(#9'mov di, 000',HexBuf,'h');
			WriteLn(#9'push ax');
			WriteLn(#9' call Read');
			WriteLn(#9' add al, cl');
			WriteLn(#9' xor ah, ah');
			WriteLn(#9' mov si, ax');
			WriteLn(#9'pop ax');
			WriteLn(#9'call Write')
		End
	End
End;

Procedure Run(w: Word); Forward;

Procedure CondJump(w: Word; i: Integer; Num, j1, j2: PChar);
Begin
	If Gen86 Then WriteLn(#9'test FlagReg,',Num:3);
	If Ord(fROM[Pages[RelAddr Shr 12]][RelAddr And $FFF])And 1 = 0 Then
	Begin
		If Gen86 Then
		Begin
			LHex(HexBuf, w+i);
			WriteLn(#9,j1,' P',HexBuf+3)
		End;
		Run(RelAddr)
	End
	Else
	Begin
		If Gen86 Then
		Begin
			LHex(HexBuf, RelAddr);
			WriteLn(#9,j2,' P',HexBuf+3)
		End
	End
End;

Var
	XInc, YInc: Integer;
	IncStart: LongInt;
	IncLatest: Byte;

Procedure CheckIncs;
Begin
	If IncStart <> -1 Then
	Begin
		If Gen86 Then
		Begin
			LHex(HexBuf, IncStart);
			{WriteLn(#9#9'; Flush inc/dec');}

			If XInc = 1 Then WriteLn(#9'inc bl')
			Else If XInc = 2 Then WriteLn(#9'inc bl'^J#9'inc bl')
			Else If XInc > 2 Then WriteLn(#9'add bl, ',XInc)
			Else If XInc = -1 Then WriteLn(#9'dec bl')
			Else If XInc = -2 Then WriteLn(#9'dec bl'^J#9'dec bl')
			Else If XInc < -2 Then WriteLn(#9'sub bl, ',XInc);

			If YInc = 1 Then WriteLn(#9'inc cl')
			Else If YInc = 2 Then WriteLn(#9'inc cl'^J#9'inc cl')
			Else If YInc > 2 Then WriteLn(#9'add cl, ',YInc)
			Else If YInc = -1 Then WriteLn(#9'dec cl')
			Else If YInc = -2 Then WriteLn(#9'dec cl'^J#9'dec cl')
			Else If YInc < -2 Then WriteLn(#9'sub cl, ',YInc);

			If IncLatest = 1
				Then FlagSet($FFFF, 'bl')
				Else FlagSet($FFFF, 'cl')
		End;

		IncStart := -1;
		XInc := 0;
		YInc := 0
	End
End;

Procedure ADCCommand;
Var SavedLoc: Integer;
Begin
	WriteLn(#9'test FlagReg, 8'#9'; test DF');
	WriteLn(#9'jz @@',LocalLoc);

	WriteLn(#9'push bx');
	WriteLn(#9' push cx');
	WriteLn(#9'  push dx');
	WriteLn(#9'   mov dl, FlagReg');
	WriteLn(#9'   and dl, 1');  {start dl calculation}
	WriteLn(#9'   mov bl, dl');
	WriteLn(#9'   mov bh, ah');
	WriteLn(#9'   and bh, 15');
	WriteLn(#9'   mov ch, al');
	WriteLn(#9'   and ch, 15');
	WriteLn(#9'   add dl, bh');
	WriteLn(#9'   add dl, ch'); {dl = lower nibble}
	WriteLn(#9'   mov bh, ah'); {start dh calculation}
	WriteLn(#9'   shr bh, 4');
	WriteLn(#9'   mov ch, al');
	WriteLn(#9'   shr ch, 4');
	WriteLn(#9'   mov dh, 0');
	WriteLn(#9'   add dh, bh');
	WriteLn(#9'   add dh, ch');
	WriteLn(#9'   cmp dl, 15');
	WriteLn(#9'   jbe @@',LocalLoc+2);
	WriteLn(#9'   inc dh');
	Write('@@',LocalLoc+2,':'); {dh = upper nibble}
	WriteLn(#9'   cmp dl, 9');
	WriteLn(#9'   jbe @@',LocalLoc+3);
	WriteLn(#9'   add dl, 6');
	Write('@@',LocalLoc+3,':');
	WriteLn(#9'   and FlagReg, 3Ch'#9';Clear C,Z,O,S F');
	WriteLn(#9'   mov cl, bl');
	WriteLn(#9'   add cl, al');
	WriteLn(#9'   add cl, ah');
	WriteLn(#9'   jz @@',LocalLoc+4);
	WriteLn(#9'   or FlagReg, 2');
	Write('@@',LocalLoc+4,':');
	WriteLn(#9'   test dh, 8');
	WriteLn(#9'   jz @@',LocalLoc+5);
	WriteLn(#9'   or FlagReg, 128');
	Write('@@',LocalLoc+5,':');
	WriteLn(#9'   mov cl, dh');
	WriteLn(#9'   shl cl, 4');
	WriteLn(#9'   xor cl, ah');
	WriteLn(#9'   test cl, 128');
	WriteLn(#9'   jz @@',LocalLoc+6);
	WriteLn(#9'   mov cl, ah');
	WriteLn(#9'   xor cl, al');
	WriteLn(#9'   test cl, 128');
	WriteLn(#9'   jnz @@',LocalLoc+6);
	WriteLn(#9'   or FlagReg, 64');
	Write('@@',LocalLoc+6,':');
	WriteLn(#9'   cmp dh, 9');
	WriteLn(#9'   jbe @@',LocalLoc+7);
	WriteLn(#9'   add dh, 6');
	Write('@@',LocalLoc+7,':');
	WriteLn(#9'   cmp ah, 15');
	WriteLn(#9'   jbe @@',LocalLoc+8);
	WriteLn(#9'   or FlagReg, 1');
	Write('@@',LocalLoc+8,':');
	WriteLn(#9'   mov ah, dl');
	WriteLn(#9'   shl dh, 4');
	WriteLn(#9'   add ah, dh');
	WriteLn(#9'  pop dx');
	WriteLn(#9' pop cx');
	WriteLn(#9'pop bx');
	WriteLn(#9'xor dh, dh');
	WriteLn(#9'jmp @@',LocalLoc+1);
	Write('@@',LocalLoc,':');

	WriteLn(#9'push dx');
	WriteLn(#9' mov dl, FlagReg');
	WriteLn(#9' and dx, 1');
	WriteLn(#9' add dl, ah');
	WriteLn(#9' adc dh, 0');
	WriteLn(#9' add dl, al');
	WriteLn(#9' adc dh, 0');
	Inc(LocalLoc);
	SavedLoc := LocalLoc;
	Inc(LocalLoc, 8);
	FlagSetCmp('dl');
	WriteLn(#9' mov ah, dl');
	WriteLn(#9'pop dx');

	Write('@@',SavedLoc,':')
End;

Procedure SBCCommand;
Var SavedLoc: Integer;
Begin
	WriteLn(#9'test FlagReg, 8'#9'; test DF');
	WriteLn(#9'jz @@',LocalLoc);

	WriteLn(#9'push bx');
	WriteLn(#9' push cx');
	WriteLn(#9'  push dx');
	WriteLn(#9'   mov dl, FlagReg');
	WriteLn(#9'   and dl, 1');
	WriteLn(#9'   xor dl, 1');
	WriteLn(#9'   mov bl, dl');
	WriteLn(#9'   mov bh, ah');
	WriteLn(#9'   and bh, 15');
	WriteLn(#9'   mov ch, al');
	WriteLn(#9'   and ch, 15');
	WriteLn(#9'   sub dl, bh');
	WriteLn(#9'   sub dl, ch'); {dl = lower nibble}

	WriteLn(#9'   test dl, 16');
	WriteLn(#9'   jz @@',LocalLoc+2);
	WriteLn(#9'   sub dl, 6');
	Write('@@',LocalLoc+2,':');

	WriteLn(#9'   mov bh, ah');
	WriteLn(#9'   shr bh, 4');
	WriteLn(#9'   mov ch, al');
	WriteLn(#9'   shr ch, 4');
	WriteLn(#9'   mov dh, dl');
	WriteLn(#9'   and dh, 16');
	WriteLn(#9'   neg dh');
	WriteLn(#9'   add dh, bh');
	WriteLn(#9'   sub dh, ch'); {dh = bh - ch - (dl&16) = upper nibble}

	WriteLn(#9'   test dh, 16');
	WriteLn(#9'   jz @@',LocalLoc+3);
	WriteLn(#9'   sub dh, 6');
	Write('@@',LocalLoc+3,':');

	WriteLn(#9'jmp @@',LocalLoc+1);
	Write('@@',LocalLoc,':');

	WriteLn(#9'push dx');
	WriteLn(#9' mov dl, FlagReg');
	WriteLn(#9' and dx, 1');
	WriteLn(#9' xor dx, 1');
	WriteLn(#9' sub dl, ah');
	WriteLn(#9' sbb dh, 0');
	WriteLn(#9' sub dl, al');
	WriteLn(#9' sbb dh, 0');
	Inc(LocalLoc);
	SavedLoc := LocalLoc;
	Inc(LocalLoc, 4);
	FlagSetCmp('dl');
	WriteLn(#9' mov ah, dl');
	WriteLn(#9'pop dx');

	Write('@@',SavedLoc,':')
End;

Procedure Run(w: Word);
Var
	TBuf: Array[0..127]Of Char;
	p, i, a, b: Integer;
	SavedLoc: LongInt;
Begin
	p := Pages[w Shr 12];
	If Ord(fROM[p][w And $FFF])And 1 = 0 Then
		Repeat
			p := Pages[w Shr 12];
			If Ord(fROM[p][w And $FFF])And 1 <> 0 Then
			Begin
				LHex(HexBuf, w);
				WriteLn(#9'jmp P',HexBuf+3,#9'; We have compiled this yet');
				Break
			End;

			LocalLoc := 0;

			i := DAsm(TBuf, pROM[p] + (w And $FFF), w);

			fROM[p][w And $FFF] := #1;
			For a := 1 To i-1 Do
			Begin
				b := Pages[(w+a)Shr 12];
				fROM[b][(w+a)And $FFF] := #2
			End;

			If Not(AD[OP]In[21..24])Then CheckIncs;

			LHex(HexBuf, w);
			WriteLn('P',HexBuf+3,':'#9'; ',TBuf);

			Case AD[OP]Of
				3:  {bcc} CondJump(w,i,   '1', 'jnz',  'jz');
				4:  {bcs} CondJump(w,i,   '1',  'jz', 'jnz');
				8:  {bne} CondJump(w,i,   '2', 'jnz',  'jz');
				5:  {beq} CondJump(w,i,   '2',  'jz', 'jnz');
				9:  {bpl} CondJump(w,i, '80h', 'jnz',  'jz');
				7:  {bmi} CondJump(w,i, '80h',  'jz', 'jnz');
				11: {bvc} CondJump(w,i, '40h', 'jnz',  'jz');
				12: {bvs} CondJump(w,i, '40h',  'jz', 'jnz');

				2: {asl}
				Begin
					ReadSource('');
					If Gen86 Then
					Begin
						WriteLn(#9'and FlagReg, 254'#9';Clear CF');
						WriteLn(#9'mov dh, al');
						WriteLn(#9'shr dh, 7');
						WriteLn(#9'or FlagReg, dh');
						WriteLn(#9'xor dh, dh');
						WriteLn(#9'add al, al');
						WriteDest;
						FlagSet($FFFF, Nil)
					End
				End;

				33: {lsr}
				Begin
					ReadSource('');
					If Gen86 Then
					Begin
						WriteLn(#9'and FlagReg, 254'#9';Clear CF');
						WriteLn(#9'mov dh, al');
						WriteLn(#9'and dh, 1');
						WriteLn(#9'or FlagReg, dh');
						WriteLn(#9'shr al, 1');
						WriteLn(#9'xor dh, dh');
						WriteDest;
						FlagSet($FFFF, Nil)
					End
				End;

				0: {adc}
				Begin
					ReadSource('');
					If Gen86 Then WriteLn(#9'call ADC_Command')
				End;

				43: {sbc}
				Begin
					ReadSource('');
					If Gen86 Then WriteLn(#9'call SBC_Command')
				End;

				39: {rol}
				Begin
					ReadSource('');
					If Gen86 Then
					Begin
						WriteLn(#9'add al, al');
						WriteLn(#9'mov dh, FlagReg');
						WriteLn(#9'and dh, 1');
						WriteLn(#9'add al, dh');
						WriteLn(#9'and FlagReg, 254'#9';Clear CF');
						WriteLn(#9'mov dh, al');
						WriteLn(#9'shr dh, 7');
						WriteLn(#9'or FlagReg, dh');
						WriteLn(#9'xor dh, dh');
						WriteDest;
						FlagSet($FFFF, Nil)
					End
				End;

				40: {ror}
				Begin
					ReadSource('');
					If Gen86 Then
					Begin
						WriteLn(#9'add al, al');
						WriteLn(#9'mov dh, FlagReg');
						WriteLn(#9'shl dh, 7');
						WriteLn(#9'shr al, 1');
						WriteLn(#9'or al, dh');
						WriteLn(#9'mov dh, al');
						WriteLn(#9'and FlagReg, 254'#9';Clear CF');
						WriteLn(#9'and dh, 1');
						WriteLn(#9'or FlagReg, dh');
						WriteLn(#9'xor dh, dh');
						WriteDest;
						FlagSet($FFFF, Nil)
					End
				End;

				21: {dex}
				Begin
					If IncStart=-1 Then IncStart := w;
					Dec(XInc); IncLatest := 1;
					CheckIncs
				End;

				22: {dey}
				Begin
					If IncStart=-1 Then IncStart := w;
					Dec(YInc); IncLatest := 2;
					CheckIncs
				End;
				23: {inx}
				Begin
					If IncStart=-1 Then IncStart := w;
					Inc(XInc); IncLatest := 1;
					CheckIncs
				End;
				24: {iny}
				Begin
					If IncStart=-1 Then IncStart := w;
					Inc(YInc); IncLatest := 2;
					CheckIncs
				End;

				20: {dec}
				Begin
					ReadSource('');
					If Gen86 Then
					Begin
						WriteLn(#9'dec al');
						WriteDest;
						FlagSet($FFFF, Nil)
					End
				End;

				26: {inc}
				Begin
					ReadSource('');
					If Gen86 Then
					Begin
						WriteLn(#9'inc al');
						WriteDest;
						FlagSet($FFFF, Nil)
					End
				End;

				13: {clc} If Gen86 Then WriteLn(#9'and FlagReg, 0FEh'#9';Clear CF');
				14: {cld} If Gen86 Then WriteLn(#9'and FlagReg, 0F7h'#9';Clear DF');
				15: {cli} If Gen86 Then WriteLn(#9'and FlagReg, 0FBh'#9';Clear IF');
				16: {clv} If Gen86 Then WriteLn(#9'and FlagReg, 0BFh'#9';Clear OF');

				47: {sec} If Gen86 Then WriteLn(#9'or FlagReg, 1'#9#9';Set CF');
				48: {sed} If Gen86 Then WriteLn(#9'or FlagReg, 8'#9#9';Set DF');
				49: {sei} If Gen86 Then WriteLn(#9'or FlagReg, 4'#9#9';Set IF');

				54: {tsx} If Gen86 Then WriteLn(#9'mov bl, dl');
				55: {txs} If Gen86 Then WriteLn(#9'mov dl, bl');

				50: {tax} If Gen86 Then Begin WriteLn(#9'mov ah, bl'); FlagSet($FFFF, 'ah')End;
				51: {tay} If Gen86 Then Begin WriteLn(#9'mov ah, cl'); FlagSet($FFFF, 'ah')End;
				52: {txa} If Gen86 Then Begin WriteLn(#9'mov bl, ah'); FlagSet($FFFF, 'ah')End;
				53: {tya} If Gen86 Then Begin WriteLn(#9'mov cl, ah'); FlagSet($FFFF, 'ah')End;

				27: {jmp}
				Begin
					Case AD[OP+1]Of
						Ab:
						Begin
							If Ord(fROM[Pages[RelAddr Shr 12]][RelAddr And $FFF])And 1 = 0 Then
							Begin
								i := 0;
								w := RelAddr
							End
							Else
							Begin
								If Gen86 Then
								Begin
									LHex(HexBuf, RelAddr);
									WriteLn(#9'jmp P',HexBuf+3)
								End;
								Exit
							End
						End;
						_In:
							If Gen86 Then
							Begin
								LHex(HexBuf, RelAddr);
								WriteLn(#9'mov si, 0',HexBuf,'h');
								WriteLn(#9'push si');
								WriteLn(#9' call Read');
								WriteLn(#9'pop si');
								WriteLn(#9'inc si');
								WriteLn(#9'push ax');
								WriteLn(#9' call Read');
								WriteLn(#9' mov di, ax');
								WriteLn(#9'pop ax');
								WriteLn(#9'shl di, 8');
								WriteLn(#9'push ax');
								WriteLn(#9' xor ah, ah');
								WriteLn(#9' or di, ax');
								WriteLn(#9'pop ax');
								WriteLn(#9'jmp IndirectJump')
							End
					End
				End;
				28: {jsr}
				Begin
					If Gen86 Then
					Begin
						LHex(HexBuf, w+i);
						WriteLn(#9'push ax');
						WriteLn(#9' mov ax, ',HexBuf+3,'h');
						WriteLn(#9' mov dh, 1');
						WriteLn(#9' mov di, dx');
						WriteLn(#9' dec dx');
						WriteLn(#9' xchg al, ah'#9';ah first');
						WriteLn(#9' call Write');
						WriteLn(#9' mov dh, 1');
						WriteLn(#9' mov di, dx');
						WriteLn(#9' dec dx');
						WriteLn(#9' xchg al, ah'#9';al last');
						WriteLn(#9' call Write');
						WriteLn(#9' xor dh, dh');
						WriteLn(#9'pop ax');
					End;

					If Ord(fROM[Pages[RelAddr Shr 12]][RelAddr And $FFF])And 1 = 0 Then
						Run(RelAddr)
					Else If Gen86 Then
					Begin
						LHex(HexBuf, RelAddr);
						WriteLn(#9'jmp P',HexBuf+3)
					End
				End;

				42: {rts}
					If Gen86 Then
					Begin
						WriteLn(#9'inc dx');
						WriteLn(#9'mov dh, 1');
						WriteLn(#9'mov si, dx');
						WriteLn(#9'call Read');
						WriteLn(#9'push ax');
						WriteLn(#9' inc dx');
						WriteLn(#9' mov dh, 1');
						WriteLn(#9' mov si, dx');
						WriteLn(#9' call Read');
						WriteLn(#9' mov di, ax');
						WriteLn(#9'pop si');
						WriteLn(#9'and di, 255');
						WriteLn(#9'shl si, 8');
						WriteLn(#9'or di, si');
						WriteLn(#9'xor dh, dh');
						WriteLn(#9'jmp IndirectJump');
						Exit
					End;

				35: {pha}
					If Gen86 Then
					Begin
						WriteLn(#9'mov dh, 1');
						WriteLn(#9'mov al, ah');
						WriteLn(#9'mov di, dx');
						WriteLn(#9'dec dx');
						WriteLn(#9'call Write');
						WriteLn(#9'xor dh, dh')
					End;
				36: {php}
					If Gen86 Then
					Begin
						WriteLn(#9'mov dh, 1');
						WriteLn(#9'mov al, FlagReg');
						WriteLn(#9'mov di, dx');
						WriteLn(#9'dec dx');
						WriteLn(#9'call Write');
						WriteLn(#9'xor dh, dh')
					End;
				37: {pla}
					If Gen86 Then
					Begin
						WriteLn(#9'inc dx');
						WriteLn(#9'mov dh, 1');
						WriteLn(#9'mov si, dx');
						WriteLn(#9'call Read');
						WriteLn(#9'xor dh, dh');
						WriteLn(#9'mov ah, al');
						FlagSet($FFFF, Nil)
					End;
				38: {plp}
					If Gen86 Then
					Begin
						WriteLn(#9'inc dx');
						WriteLn(#9'mov dh, 1');
						WriteLn(#9'mov si, dx');
						WriteLn(#9'call Read');
						WriteLn(#9'or al, 32'#9';Bit is always 1');
						WriteLn(#9'mov FlagReg, al')
					End;

				29, {lda}
				31, {ldx}
				32: {ldy}
				Begin
					ReadSource(Nil);
					If Gen86 Then
						Case AD[OP]Of
							29: WriteLn(#9'mov ah, al');
							31: WriteLn(#9'mov bl, al');
							32: WriteLn(#9'mov cl, al')
						End
				End;
				44, {sta}
				45, {stx}
				46: {sty}
					If Gen86 Then
					Begin
						Case AD[OP]Of
							44: WriteLn(#9'mov al, ah');
							45: WriteLn(#9'mov al, bl');
							46: WriteLn(#9'mov al, cl')
						End;
						WriteDest
					End;
				17, {cmp}
				18, {cpx}
				19: {cpy}
				Begin
					ReadSource(Nil);

					If Gen86 Then
					Begin
						Case AD[OP]Of
							17: WriteLn(#9'sub al, ah');
							18: WriteLn(#9'sub al, bl');
							19: WriteLn(#9'sub al, cl')
						End;
						WriteLn(#9'sbb dh, 0');
						WriteLn(#9'neg al');
						FlagSetCmp(Nil);
						WriteLn(#9'xor dh, dh')
					End
				End;

				 1: {and} ReadSource(#9'and ah, ');
				34: {ora} ReadSource(#9'or ah, ');
				25: {eor} ReadSource(#9'xor ah, ');

				6: {bit}
				Begin
					ReadSource('');
					If Gen86 Then FlagSetBit
				End
			End;

			Inc(w, i)
		Until False;

	CheckIncs
End;

Procedure DoIt(s: PChar);
Var
	w: Word;
	i, a, b, l: Integer;
	Buf: Array[0..15]Of Char;
	f: File;
Begin
	Assign(f, s);
	Reset(f, 1);
	BlockRead(f, Buf, 4);
	Buf[4] := #0;
	If strcmp(Buf, 'NES'^Z) <> 0 Then
	Begin
		Close(f);
		WriteLn('Unknown format.');
		Exit
	End;
	BlockRead(f, pROMCount, 1);
	BlockRead(f, vROMCount, 1);

	pROMCount := pROMCount*4; {16kB divided into 4kB blocks}
	vROMCount := vROMCount*2; { 8kB divided into 4kB blocks}

	BlockRead(f, NESFlags, 2);
	Mapper := (Lo(NESFlags)Shr 4) + (Hi(NESFlags)And $F0);

	BlockRead(f, Buf, 8); {Should be zeroes all}
												{Not something like "diskdude"}

	HASTrainer := (NESFlags And 4 <> 0);

	If HASTrainer Then
	Begin
		GetMem(Trainer, 512);
		BlockRead(f, Trainer^, 512);
	End;

	For i := 1 To pROMCount Do
	Begin
		GetMem(pROM[i-1], 4096);
		GetMem(fROM[i-1], 4096);
		BlockRead(f, pROM[i-1]^, 4096);
		FillChar(fROM[i-1]^, 4096, 0)
	End;

	For i := 1 To vROMCount Do
	Begin
		GetMem(vROM[i-1], 4096);
		BlockRead(f, vROM[i-1]^, 4096)
	End;

	If FilePos(f) <> FileSize(f)Then
		WriteLn('; Garbage after should-be file end ignored.');

	WriteLn(#9'; File has pROM ', pROMCount*4,'kB, vROM ',vROMCount*4,'kB.');

	SwapInOut;

	Close(f);

	If Gen86 Then
	Begin
		WriteLn('.286c');
		WriteLn(#9'locals @@');
		WriteLn(#9'jumps');
		WriteLn;
		WriteLn('data'#9'segment word public');
		WriteLn(#9'org 8000h');
		If Trainer <> Nil Then
		Begin
			WriteLn('Trainer:');
			For i := 0 To 511 Do
			Begin
				If i And 7 = 0 Then Write(#9'db ');
				BHex(Buf, Ord(Trainer[i]));
				Write('0',Buf,'h');
				If i And 7 = 7 Then WriteLn Else Write(', ');
			End
		End;
		WriteLn('KBuf db 128 dup (?)');
		WriteLn('IntRAM'#9'db 2048 dup (?)');
		WriteLn('Battery'#9'db 4096 dup (?)');
		WriteLn('PPU'#9'dw ?,?');
		WriteLn('PPU2000'#9'db ?');
		WriteLn('PPU2001'#9'db ?');
		WriteLn('PPU2002'#9'db ?');
		WriteLn('PPU2003'#9'db ?');
		WriteLn('PPU2006'#9'dw ?');
		WriteLn('Joy1Step'#9'db ?');
		WriteLn('Joy2Step'#9'db ?');
		WriteLn('ROM'#9'db 8000h dup(?)');
		WriteLn('data'#9'ends');
		WriteLn;
		WriteLn('data2'#9'segment word public');
		WriteLn('data2'#9'ends');
		WriteLn;
		WriteLn('code'#9'segment byte public');
		WriteLn(#9'assume cs:code,ds:data,es:data2,ss:pino');
		WriteLn(#9'extrn Write:far');
		WriteLn(#9'FlagReg'#9'db 22h'#9';ZF + the 1-bit');
		WriteLn('Start:'#9'; Here starts the NES code');
		WriteLn(#9'mov ax,data'#9'; P = FlagReg');
		WriteLn(#9'mov ds,ax'#9'; A = ah');
		WriteLn(#9'xor bx,bx'#9'; X = bl');
		WriteLn(#9'and cx,bx'#9'; Y = cl');
		WriteLn(#9'sub dx,dx'#9'; S = dl');
	End;
	For i := 0 To 3 Do
	Begin
		Pages[ 8+i] := i;
		Pages[12+i] := i+pROMCount-4
	End;

	XInc := 0;
	YInc := 0;
	IncStart := -1;

	WordRec(i).Lo := Ord(pROM[Pages[15]][$FFC]);
	WordRec(i).Hi := Ord(pROM[Pages[15]][$FFD]);
	Run(Word(i));

	If Gen86 Then
	Begin
		WriteLn;
		WriteLn(#9'; The NMI vector');
		WordRec(i).Lo := Ord(pROM[Pages[15]][$FFA]);
		WordRec(i).Hi := Ord(pROM[Pages[15]][$FFB]);
		Run(Word(i));

		WriteLn;
		WriteLn(#9'; The IRQ vector / BRK vector');
		WordRec(i).Lo := Ord(pROM[Pages[15]][$FFE]);
		WordRec(i).Hi := Ord(pROM[Pages[15]][$FFF]);
		Run(Word(i));

		WriteLn;
		WriteLn;

		WriteLn('ADC_Command:'#9'; Does the ADC command');
		ADCCommand;
		WriteLn(#9'retn');

		WriteLn;
		WriteLn('SBC_Command:'#9'; Does the SBC command');
		SBCCommand;
		WriteLn(#9'retn');

		WriteLn;
		WriteLn('Read:');
		WriteLn(#9'cmp si, 2000h');
		WriteLn(#9'jae @@1');
		WriteLn(#9'and si, 2047');
		WriteLn(#9'mov al, IntRAM[si]');
		WriteLn(#9'retn');
		Write('@@1:');
		WriteLn(#9'test si, 8000h');
		WriteLn(#9'jz @@2');
		WriteLn(#9'and si, 7FFFh');
		WriteLn(#9'mov al, THE_ROM[si]');
		WriteLn(#9'retn');
		Write('@@2:');
		WriteLn(#9'cmp si, 6000h');
		WriteLn(#9'jb @@3');
		WriteLn(#9'cmp si, 7000h');
		WriteLn(#9'jae @@4');
		WriteLn(#9'and si, 4095');
		WriteLn(#9'mov al, Battery[si]');
		WriteLn(#9'retn');
		Write('@@4:');
		If HASTrainer Then
		Begin
			WriteLn(#9'cmp si, 7100h');
			WriteLn(#9'jae @@5');
			WriteLn(#9'and si, 255');
			WriteLn(#9'mov al, Trainer[si]');
			WriteLn(#9'retn');
			Write('@@5:')
		End;
		WriteLn(#9'sub si, 6000h');
		WriteLn(#9'mov al, Battery[si]');
		WriteLn(#9'retn');
		Write('@@3:');

		WriteLn(#9'cmp si, 2000h'^M^J#9'jne @@10'^M^J#9'mov al, PPU2000'^M^J#9'ret');
		Write('@@10:');
		WriteLn(#9'cmp si, 2001h'^M^J#9'jne @@10'^M^J#9'mov al, PPU2001'^M^J#9'ret');
		Write('@@11');
		WriteLn(#9'cmp si, 2002h');
		WriteLn(#9'jne @@12');
		WriteLn(#9'mov al, PPU2002');
		WriteLn(#9'and PPU2002, 3Fh');
		WriteLn(#9'retn');
		Write('@@12:');
		WriteLn(#9'cmp si, 2004h');
		WriteLn(#9'jne @@13');
		WriteLn(#9'push bx');
		WriteLn(#9' xor bh, bh');
		WriteLn(#9' mov bl, PPU2003');
		WriteLn(#9' mov al, SpriteMem[bx]');
		WriteLn(#9'pop bx');
		WriteLn(#9'retn');
		Write('@@13:');
		WriteLn(#9'cmp si, 2007h');
		WriteLn(#9'jne @@14');
		WriteLn(#9'push si');
		WriteLn(#9' mov si, PPU2006');
		WriteLn(#9' call PPURead');
		WriteLn(#9'pop si');
		WriteLn(#9'test PPU2000, 4');
		WriteLn(#9'jnz @@15');
		WriteLn(#9'add PPU2006, 31');
		Write('@@15:');
		WriteLn(#9'inc PPU2006');
		WriteLn(#9'retn');
		Write('@@14:');


		WriteLn;
		WriteLn('PPURead:');
		WriteLn(#9'cmp si, 3F10h');
		WriteLn(#9'jnz @@1');
		WriteLn(#9'mov al, PPURest[si]');
		WriteLn(#9'ret');
		Write('@@1:');
		WriteLn(#9'cmp si, 2000h');
		WriteLn(#9'jb @@2');
		WriteLn(#9'push bx');
		WriteLn(#9' mov bx, si');
		WriteLn(#9' shr bx, 10');
		WriteLn(#9' and bx, 12');
		WriteLn(#9' les bx, PPU[bx]');
		WriteLn(#9' and si, 4095');
		WriteLn(#9' mov al, es:[bx+si]');
		WriteLn(#9'pop bx');
		WriteLn(#9'ret');
		Write('@@2:');
		WriteLn(#9'cmp si, 3000h');
		WriteLn(#9'jb @@3');
		WriteLn(#9'and si, 4095');
		WriteLn(#9'mov al, es:PPURest[si]');
		WriteLn(#9'ret');
		Write('@@3:');
		WriteLn(#9'push bx');
		WriteLn(#9' mov bx, si');
		WriteLn(#9' shr bx, 10');
		WriteLn(#9' and bx, 3');
		WriteLn(#9' les bx, NameTab[bx]');
		WriteLn(#9' and si, 1023');
		WriteLn(#9' mov al, es:[bx+si]');
		WriteLn(#9'pop bx');
		WriteLn(#9'ret');





		WriteLn;
		WriteLn('IndirectJump:'#9'; Does the RTS and JMP (xxxx) commands');
		WriteLn(#9'mov di, offset JumpTab');
		WriteLn(#9'push ax');
		WriteLn(#9' mov ax, data2');
		WriteLn(#9' mov es, ax');
		Write('@@1:');
		WriteLn(#9' mov ax, es:[si]');
		WriteLn(#9' mov bp, es:[si+2]');
		WriteLn(#9' cmp ax, -1');
		WriteLn(#9' je @@9');
		WriteLn(#9' add si, 4');
		WriteLn(#9' cmp ax, di');
		WriteLn(#9' jne @@1');
		WriteLn(#9'pop ax');
		WriteLn(#9'jmp bp');
		Write('@@9:');
		WriteLn(#9'pop ax');
		WriteLn(#9'; This is a trouble. The address indirectly');
		WriteLn(#9'; jumped to did not exist. Let''s reset.');
		WriteLn(#9'jmp Start');

		WriteLn;
		WriteLn('FlagSet:');
		FlagSet($FFFE, Nil);

		WriteLn;
		WriteLn('FlagSetCmp:');
		FlagSetCmp(Nil);

		WriteLn('code'#9'ends');
		WriteLn;
		WriteLn('data2'#9'segment word public');
		WriteLn('JumpTab'#9'label word');
		i := 0;
		For w := $8000 To $FFFF Do
			If Ord(fROM[Pages[w Shr 12]][w And $FFF]) = 1 Then
			Begin
				LHex(Buf, w);
				If i = 3 Then Begin WriteLn; i := 0 End;
				If i = 0 Then Write(#9'dw ')Else Write(', ');
				Write('0',Buf+4,'h,offset P',Buf+3);
				Inc(i)
			End;
		If i>0 Then WriteLn;
		WriteLn(#9'dw -1');
		WriteLn('data2'#9'ends');
		WriteLn;
		WriteLn('data'#9'segment word public');
		WriteLn(#9'org 0');
		WriteLn('THE_ROM:');
		i := $40;
		For w := $8000 To $FFFF Do
		Begin
			WHex(Buf, w);
			If Ord(fROM[Pages[w Shr 12]][w And $FFF]) = 0 Then
			Begin
				If i And $C0 <> $80 Then
				Begin
					If (i And $3F) > 0 Then WriteLn;
					Write('da_',Buf,#9);
					i := $80
				End
			End
			Else
			Begin
				If i And $C0 <> $C0 Then
				Begin
					If (i And $3F) > 0 Then WriteLn;
					Write('co_',Buf,#9);
					i := $C0
				End
			End;

			If (i And $1F) > 0 Then Write(', ');
			BHex(Buf, Ord(pROM[Pages[w Shr 12]][w And $FFF]));
			Write('0',Buf,'h');
			If (i And $1F) = 7 Then
			Begin
				WriteLn;
				Write(#9);
				i := (i And $C0)Or $20
			End
			Else
				Inc(i)
		End;
		WriteLn;
		WriteLn('pino'#9'segment stack');
		WriteLn(#9'db 256 dup (?)');
		WriteLn('pino'#9'ends');
		WriteLn;
		WriteLn('end'#9'Start')
	End;
End;

Var
	s: Array[0..127]Of Char;
Begin
	ClrScr;
	DirectVideo := False;

	GetArgStr(s, 1, 127);
	DoIt(s)
End.
